Index: source/tools/atlas/GameInterface/View.cpp
===================================================================
--- source/tools/atlas/GameInterface/View.cpp	(revision 13108)
+++ source/tools/atlas/GameInterface/View.cpp	(working copy)
@@ -254,10 +254,9 @@
 		{
 			cmpPathfinder->SetDebugOverlay(true);
 			// Kind of a hack to make it update the terrain grid
-			ICmpPathfinder::Goal goal = { ICmpPathfinder::Goal::POINT, fixed::Zero(), fixed::Zero() };
+			PathGoal goal = { PathGoal::POINT, fixed::Zero(), fixed::Zero() };
 			ICmpPathfinder::pass_class_t passClass = cmpPathfinder->GetPassabilityClass(m_DisplayPassability);
-			ICmpPathfinder::cost_class_t costClass = cmpPathfinder->GetCostClass("default");
-			cmpPathfinder->SetDebugPath(fixed::Zero(), fixed::Zero(), goal, passClass, costClass);
+			cmpPathfinder->SetDebugPath(fixed::Zero(), fixed::Zero(), goal, passClass);
 		}
 	}
 
Index: source/simulation2/serialization/SerializeTemplates.h
===================================================================
--- source/simulation2/serialization/SerializeTemplates.h	(revision 13108)
+++ source/simulation2/serialization/SerializeTemplates.h	(working copy)
@@ -191,9 +191,9 @@
 struct SerializeGoal
 {
 	template<typename S>
-	void operator()(S& serialize, const char* UNUSED(name), ICmpPathfinder::Goal& value)
+	void operator()(S& serialize, const char* UNUSED(name), PathGoal& value)
 	{
-		SerializeU8_Enum<ICmpPathfinder::Goal::Type, ICmpPathfinder::Goal::SQUARE>()(serialize, "type", value.type);
+		SerializeU8_Enum<PathGoal::Type, PathGoal::SQUARE>()(serialize, "type", value.type);
 		serialize.NumberFixed_Unbounded("goal x", value.x);
 		serialize.NumberFixed_Unbounded("goal z", value.z);
 		serialize.NumberFixed_Unbounded("goal u x", value.u.X);
Index: source/simulation2/helpers/Render.h
===================================================================
--- source/simulation2/helpers/Render.h	(revision 13108)
+++ source/simulation2/helpers/Render.h	(working copy)
@@ -64,7 +64,8 @@
  * @param[in] floating If true, the line conforms to water as well.
  * @param[in] heightOffset Height above terrain to offset the line.
  */
-void ConstructLineOnGround(const CSimContext& context, const std::vector<float>& xz,
+void ConstructLineOnGround(
+		const CSimContext& context, const std::vector<float>& xz,
 		SOverlayLine& overlay,
 		bool floating, float heightOffset = 0.25f);
 
@@ -78,11 +79,22 @@
  * @param[in] heightOffset Height above terrain to offset the circle.
  * @param heightOffset The vertical offset to apply to points, to raise the line off the terrain a bit.
  */
-void ConstructCircleOnGround(const CSimContext& context, float x, float z, float radius,
+void ConstructCircleOnGround(
+		const CSimContext& context, float x, float z, float radius,
 		SOverlayLine& overlay,
 		bool floating, float heightOffset = 0.25f);
 
 /**
+ * Constructs overlay line as an outlined circle sector (an arc with straight lines between the
+ * endpoints and the circle's center), conforming to terrain.
+ */
+void ConstructClosedArcOnGround(
+		const CSimContext& context, float x, float z, float radius,
+		float start, float end,
+		SOverlayLine& overlay,
+		bool floating, float heightOffset = 0.25f);
+
+/**
  * Constructs overlay line as rectangle with given center and dimensions, conforming to terrain.
  *
  * @param[in] x,z Coordinates of center of rectangle.
@@ -92,7 +104,8 @@
  * @param[in] floating If true, the rectangle conforms to water as well.
  * @param[in] heightOffset Height above terrain to offset the rectangle.
  */
-void ConstructSquareOnGround(const CSimContext& context, float x, float z, float w, float h, float a,
+void ConstructSquareOnGround(
+		const CSimContext& context, float x, float z, float w, float h, float a,
 		SOverlayLine& overlay,
 		bool floating, float heightOffset = 0.25f);
 
Index: source/simulation2/helpers/Render.cpp
===================================================================
--- source/simulation2/helpers/Render.cpp	(revision 13108)
+++ source/simulation2/helpers/Render.cpp	(working copy)
@@ -67,8 +67,11 @@
 	}
 }
 
-void SimRender::ConstructCircleOnGround(const CSimContext& context, float x, float z, float radius,
-		SOverlayLine& overlay, bool floating, float heightOffset)
+static void ConstructCircleOrClosedArc(
+	const CSimContext& context, float x, float z, float radius,
+	bool isCircle,
+	float start, float end,
+	SOverlayLine& overlay, bool floating, float heightOffset)
 {
 	overlay.m_Coords.clear();
 
@@ -79,28 +82,64 @@
 	float water = 0.f;
 	if (floating)
 	{
-		CmpPtr<ICmpWaterManager> cmpWaterManager(context, SYSTEM_ENTITY);
-		if (cmpWaterManager)
-			water = cmpWaterManager->GetExactWaterLevel(x, z);
+		CmpPtr<ICmpWaterManager> cmpWaterMan(context, SYSTEM_ENTITY);
+		if (cmpWaterMan)
+			water = cmpWaterMan->GetExactWaterLevel(x, z);
 	}
 
 	// Adapt the circle resolution to look reasonable for small and largeish radiuses
-	size_t numPoints = clamp((size_t)(radius*4.0f), (size_t)12, (size_t)48);
+	size_t numPoints = clamp((size_t)(radius*(end-start)), (size_t)12, (size_t)48);
 
-	overlay.m_Coords.reserve((numPoints + 1) * 3);
+	if (isCircle)
+		overlay.m_Coords.reserve((numPoints + 1 + 2) * 3);
+	else
+		overlay.m_Coords.reserve((numPoints + 1) * 3);
 
+	float cy;
+	if (!isCircle)
+	{
+		// Start at the center point
+		cy = std::max(water, cmpTerrain->GetExactGroundLevel(x, z)) + heightOffset;
+		overlay.m_Coords.push_back(x);
+		overlay.m_Coords.push_back(cy);
+		overlay.m_Coords.push_back(z);
+	}
+
 	for (size_t i = 0; i <= numPoints; ++i) // use '<=' so it's a closed loop
 	{
-		float a = (float)i * 2 * (float)M_PI / (float)numPoints;
-		float px = x + radius * sinf(a);
-		float pz = z + radius * cosf(a);
+		float a = start + (float)i * (end - start) / (float)numPoints;
+		float px = x + radius * cosf(a);
+		float pz = z + radius * sinf(a);
 		float py = std::max(water, cmpTerrain->GetExactGroundLevel(px, pz)) + heightOffset;
 		overlay.m_Coords.push_back(px);
 		overlay.m_Coords.push_back(py);
 		overlay.m_Coords.push_back(pz);
 	}
+
+	if (!isCircle)
+	{
+		// Return to the center point
+		overlay.m_Coords.push_back(x);
+		overlay.m_Coords.push_back(cy);
+		overlay.m_Coords.push_back(z);
+	}
 }
 
+void SimRender::ConstructCircleOnGround(
+	const CSimContext& context, float x, float z, float radius,
+	SOverlayLine& overlay, bool floating, float heightOffset)
+{
+	ConstructCircleOrClosedArc(context, x, z, radius, true, 0.0f, 2.0f*(float)M_PI, overlay, floating, heightOffset);
+}
+
+void SimRender::ConstructClosedArcOnGround(
+	const CSimContext& context, float x, float z, float radius,
+	float start, float end,
+	SOverlayLine& overlay, bool floating, float heightOffset)
+{
+	ConstructCircleOrClosedArc(context, x, z, radius, false, start, end, overlay, floating, heightOffset);
+}
+
 // This method splits up a straight line into a number of line segments each having a length ~= TERRAIN_TILE_SIZE
 static void SplitLine(std::vector<std::pair<float, float> >& coords, float x1, float y1, float x2, float y2)
 {
Index: source/simulation2/helpers/Rasterize.h
===================================================================
--- source/simulation2/helpers/Rasterize.h	(revision 0)
+++ source/simulation2/helpers/Rasterize.h	(revision 0)
@@ -0,0 +1,54 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef INCLUDED_HELPER_RASTERIZE
+#define INCLUDED_HELPER_RASTERIZE
+
+/**
+ * @file
+ * Helper functions related to rasterizing geometric shapes to grids.
+ */
+
+#include "simulation2/components/ICmpObstructionManager.h"
+
+namespace SimRasterize
+{
+
+/**
+ * Represents the set of cells (i,j) where i0 <= i < i1
+ */
+struct Span
+{
+	i16 i0;
+	i16 i1;
+	i16 j;
+};
+
+typedef std::vector<Span> Spans;
+
+/**
+ * Converts an ObstructionSquare @p shape (a rotated rectangle),
+ * expanded by the given @p clearance,
+ * into a list of spans of cells that are strictly inside the shape.
+ */
+void RasterizeRectWithClearance(Spans& spans,
+	const ICmpObstructionManager::ObstructionSquare& shape,
+	entity_pos_t clearance, entity_pos_t cellSize);
+
+}
+
+#endif // INCLUDED_HELPER_RASTERIZE
Index: source/simulation2/helpers/Rasterize.cpp
===================================================================
--- source/simulation2/helpers/Rasterize.cpp	(revision 0)
+++ source/simulation2/helpers/Rasterize.cpp	(revision 0)
@@ -0,0 +1,91 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "precompiled.h"
+
+#include "Rasterize.h"
+
+#include "simulation2/helpers/Geometry.h"
+
+void SimRasterize::RasterizeRectWithClearance(Spans& spans,
+	const ICmpObstructionManager::ObstructionSquare& shape,
+	entity_pos_t clearance, entity_pos_t cellSize)
+{
+	// Get the bounds of cells that might possibly be within the shape
+	// (We'll then test each of those cells more precisely)
+	CFixedVector2D halfSize(shape.hw + clearance, shape.hh + clearance);
+	CFixedVector2D halfBound = Geometry::GetHalfBoundingBox(shape.u, shape.v, halfSize);
+	i16 i0 = ((shape.x - halfBound.X) / cellSize).ToInt_RoundToNegInfinity();
+	i16 j0 = ((shape.z - halfBound.Y) / cellSize).ToInt_RoundToNegInfinity();
+	i16 i1 = ((shape.x + halfBound.X) / cellSize).ToInt_RoundToInfinity();
+	i16 j1 = ((shape.z + halfBound.Y) / cellSize).ToInt_RoundToInfinity();
+
+	if (j1 <= j0)
+		return; // empty bounds - this shouldn't happen
+
+	spans.reserve(j1 - j0);
+
+	for (i16 j = j0; j < j1; ++j)
+	{
+		// Find the min/max range of cells that are strictly inside the square+clearance.
+		// (Since the square+clearance is a convex shape, we can just test each
+		// corner of each cell is inside the shape.)
+		// (TODO: This potentially does a lot of redundant work.)
+		i16 spanI0 = std::numeric_limits<i16>::max();
+		i16 spanI1 = std::numeric_limits<i16>::min();
+		for (i16 i = i0; i < i1; ++i)
+		{
+			if (Geometry::DistanceToSquare(
+				CFixedVector2D(cellSize*i, cellSize*j) - CFixedVector2D(shape.x, shape.z),
+				shape.u, shape.v, CFixedVector2D(shape.hw, shape.hh), true) > clearance)
+			{
+				continue;
+			}
+
+			if (Geometry::DistanceToSquare(
+				CFixedVector2D(cellSize*(i+1), cellSize*j) - CFixedVector2D(shape.x, shape.z),
+				shape.u, shape.v, CFixedVector2D(shape.hw, shape.hh), true) > clearance)
+			{
+				continue;
+			}
+
+			if (Geometry::DistanceToSquare(
+				CFixedVector2D(cellSize*i, cellSize*(j+1)) - CFixedVector2D(shape.x, shape.z),
+				shape.u, shape.v, CFixedVector2D(shape.hw, shape.hh), true) > clearance)
+			{
+				continue;
+			}
+
+			if (Geometry::DistanceToSquare(
+				CFixedVector2D(cellSize*(i+1), cellSize*(j+1)) - CFixedVector2D(shape.x, shape.z),
+				shape.u, shape.v, CFixedVector2D(shape.hw, shape.hh), true) > clearance)
+			{
+				continue;
+			}
+
+			spanI0 = std::min(spanI0, i);
+			spanI1 = std::max(spanI1, (i16)(i+1));
+		}
+
+		// Add non-empty spans onto the list
+		if (spanI0 < spanI1)
+		{
+			Span span = { spanI0, spanI1, j };
+			spans.push_back(span);
+		}
+	}
+}
Index: source/simulation2/helpers/PriorityQueue.h
===================================================================
--- source/simulation2/helpers/PriorityQueue.h	(revision 13108)
+++ source/simulation2/helpers/PriorityQueue.h	(working copy)
@@ -32,14 +32,13 @@
 template <typename Item, typename CMP>
 struct QueueItemPriority
 {
-	bool operator()(const Item& a, const Item& b)
+	bool operator()(const Item& a, const Item& b) const
 	{
 		if (CMP()(b.rank, a.rank)) // higher costs are lower priority
 			return true;
 		if (CMP()(a.rank, b.rank))
 			return false;
 		// Need to tie-break to get a consistent ordering
-		// TODO: Should probably tie-break on g or h or something, but don't bother for now
 		if (a.id < b.id)
 			return true;
 		if (b.id < a.id)
@@ -73,21 +72,12 @@
 		push_heap(m_Heap.begin(), m_Heap.end(), QueueItemPriority<Item, CMP>());
 	}
 
-	Item* find(ID id)
+	void promote(ID id, R UNUSED(oldrank), R newrank)
 	{
-		for (size_t n = 0; n < m_Heap.size(); ++n)
+		// Loop backwards since it seems a little faster in practice
+		for (ssize_t n = m_Heap.size() - 1; n >= 0; --n)
 		{
 			if (m_Heap[n].id == id)
-				return &m_Heap[n];
-		}
-		return NULL;
-	}
-
-	void promote(ID id, R newrank)
-	{
-		for (size_t n = 0; n < m_Heap.size(); ++n)
-		{
-			if (m_Heap[n].id == id)
 			{
 #if PRIORITYQUEUE_DEBUG
 				ENSURE(m_Heap[n].rank > newrank);
@@ -104,7 +94,7 @@
 #if PRIORITYQUEUE_DEBUG
 		ENSURE(m_Heap.size());
 #endif
-		Item r = m_Heap.front();
+		Item r = m_Heap[0];
 		pop_heap(m_Heap.begin(), m_Heap.end(), QueueItemPriority<Item, CMP>());
 		m_Heap.pop_back();
 		return r;
@@ -155,7 +145,7 @@
 		return NULL;
 	}
 
-	void promote(ID id, R newrank)
+	void promote(ID id, R UNUSED(oldrank), R newrank)
 	{
 		find(id)->rank = newrank;
 	}
Index: source/simulation2/helpers/PathGoal.h
===================================================================
--- source/simulation2/helpers/PathGoal.h	(revision 0)
+++ source/simulation2/helpers/PathGoal.h	(revision 0)
@@ -0,0 +1,77 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef INCLUDED_PATHGOAL
+#define INCLUDED_PATHGOAL
+
+#include "maths/FixedVector2D.h"
+#include "simulation2/helpers/Position.h"
+
+/**
+ * Pathfinder goal.
+ * The goal can be either a point, a circle, or a square (rectangle).
+ * For circles/squares, any point inside the shape is considered to be
+ * part of the goal.
+ * Also, it can be an 'inverted' circle/square, where any point outside
+ * the shape is part of the goal.
+ */
+class PathGoal
+{
+public:
+	enum Type {
+		POINT,           // single point
+		CIRCLE,          // the area inside a circle
+		INVERTED_CIRCLE, // the area outside a circle
+		SQUARE,          // the area inside a square
+		INVERTED_SQUARE  // the area outside a square
+	} type;
+
+	entity_pos_t x, z; // position of center
+
+	CFixedVector2D u, v; // if [INVERTED_]SQUARE, then orthogonal unit axes
+
+	entity_pos_t hw, hh; // if [INVERTED_]SQUARE, then half width & height; if [INVERTED_]CIRCLE, then hw is radius
+
+	/**
+	 * Returns true if the given navcell contains a part of the goal area.
+	 */
+	bool NavcellContainsGoal(int i, int j) const;
+
+	/**
+	 * Returns true if any navcell (i, j) where
+	 * min(i0,i1) <= i <= max(i0,i1)
+	 * min(j0,j1) <= j <= max(j0,j1),
+	 * contains a part of the goal area.
+	 * If so, arguments i and j (if not NULL) are set to the goal navcell nearest
+	 * to (i0, j0), assuming the rect has either width or height = 1.
+	 */
+	bool NavcellRectContainsGoal(int i0, int j0, int i1, int j1, int* i, int* j) const;
+
+	/**
+	 * Returns true if the rectangle defined by (x0,z0)-(x1,z1) (inclusive)
+	 * contains a part of the goal area.
+	 */
+	bool RectContainsGoal(entity_pos_t x0, entity_pos_t z0, entity_pos_t x1, entity_pos_t z1) const;
+
+	/**
+	 * Returns the minimum distance from the point with the given @p pos
+	 * to any point on the outline of the goal shape.
+	 */
+	fixed DistanceToPoint(CFixedVector2D pos) const;
+};
+
+#endif // INCLUDED_PATHGOAL
Index: source/simulation2/helpers/PathGoal.cpp
===================================================================
--- source/simulation2/helpers/PathGoal.cpp	(revision 0)
+++ source/simulation2/helpers/PathGoal.cpp	(revision 0)
@@ -0,0 +1,278 @@
+/* Copyright (C) 2012 Wildfire Games.
+ * This file is part of 0 A.D.
+ *
+ * 0 A.D. is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * 0 A.D. is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with 0 A.D.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "precompiled.h"
+
+#include "PathGoal.h"
+
+#include "graphics/Terrain.h"
+#include "simulation2/components/ICmpObstructionManager.h"
+#include "simulation2/helpers/Geometry.h"
+
+static bool NavcellContainsCircle(int i, int j, fixed x, fixed z, fixed r, bool inside)
+{
+	// Accept any navcell (i,j) that contains a point which is inside[/outside]
+	// (or on the edge of) the circle
+
+	// Get world-space bounds of navcell
+	entity_pos_t x0 = entity_pos_t::FromInt(i).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+	entity_pos_t z0 = entity_pos_t::FromInt(j).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+	entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE;
+	entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE;
+
+	if (inside)
+	{
+		// Get the point inside the navcell closest to (x,z)
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		// Check if that point is inside the circle
+		return (CFixedVector2D(nx, nz) - CFixedVector2D(x, z)).CompareLength(r) <= 0;
+	}
+	else
+	{
+		// If any corner of the navcell is outside the circle, return true.
+		// Otherwise, since the circle is convex, there cannot be any other point
+		// in the navcell that is outside the circle.
+		return (
+		    (CFixedVector2D(x0, z0) - CFixedVector2D(x, z)).CompareLength(r) >= 0
+		 || (CFixedVector2D(x1, z0) - CFixedVector2D(x, z)).CompareLength(r) >= 0
+		 || (CFixedVector2D(x0, z1) - CFixedVector2D(x, z)).CompareLength(r) >= 0
+		 || (CFixedVector2D(x1, z1) - CFixedVector2D(x, z)).CompareLength(r) >= 0
+		);
+	}
+}
+
+static bool NavcellContainsSquare(int i, int j,
+	fixed x, fixed z, CFixedVector2D u, CFixedVector2D v, fixed hw, fixed hh,
+	bool inside)
+{
+	// Accept any navcell (i,j) that contains a point which is inside[/outside]
+	// (or on the edge of) the square
+
+	// Get world-space bounds of navcell
+	entity_pos_t x0 = entity_pos_t::FromInt(i).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+	entity_pos_t z0 = entity_pos_t::FromInt(j).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+	entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE;
+	entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE;
+
+	if (inside)
+	{
+		// Get the point inside the navcell closest to (x,z)
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		// Check if that point is inside the circle
+		return Geometry::PointIsInSquare(CFixedVector2D(nx - x, nz - z), u, v, CFixedVector2D(hw, hh));
+	}
+	else
+	{
+		// If any corner of the navcell is outside the square, return true.
+		// Otherwise, since the square is convex, there cannot be any other point
+		// in the navcell that is outside the square.
+		return (
+		    Geometry::PointIsInSquare(CFixedVector2D(x0 - x, z0 - z), u, v, CFixedVector2D(hw, hh))
+		 || Geometry::PointIsInSquare(CFixedVector2D(x1 - x, z0 - z), u, v, CFixedVector2D(hw, hh))
+		 || Geometry::PointIsInSquare(CFixedVector2D(x0 - x, z1 - z), u, v, CFixedVector2D(hw, hh))
+		 || Geometry::PointIsInSquare(CFixedVector2D(x1 - x, z1 - z), u, v, CFixedVector2D(hw, hh))
+		);
+	}
+}
+
+bool PathGoal::NavcellContainsGoal(int i, int j) const
+{
+	switch (type)
+	{
+	case POINT:
+	{
+		// Only accept a single navcell
+		int gi = (x / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero();
+		int gj = (z / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero();
+		return gi == i && gj == j;
+	}
+	case CIRCLE:
+		return NavcellContainsCircle(i, j, x, z, hw, true);
+	case INVERTED_CIRCLE:
+		return NavcellContainsCircle(i, j, x, z, hw, false);
+	case SQUARE:
+		return NavcellContainsSquare(i, j, x, z, u, v, hw, hh, true);
+	case INVERTED_SQUARE:
+		return NavcellContainsSquare(i, j, x, z, u, v, hw, hh, false);
+	default:
+	{
+		debug_warn(L"invalid type");
+		return false;
+	}
+	}
+}
+
+bool PathGoal::NavcellRectContainsGoal(int i0, int j0, int i1, int j1, int* gi, int* gj) const
+{
+	// Get min/max to simplify range checks
+	int imin = std::min(i0, i1);
+	int imax = std::max(i0, i1);
+	int jmin = std::min(j0, j1);
+	int jmax = std::max(j0, j1);
+
+	// Direction to iterate from ij0 towards ij1
+	int di = i1 < i0 ? -1 : +1;
+	int dj = j1 < j0 ? -1 : +1;
+
+	switch (type)
+	{
+	case POINT:
+	{
+		// Calculate the navcell that contains the point goal
+		int i = (x / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero();
+		int j = (z / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero();
+		// If that goal navcell is in the given range, return it
+		if (imin <= i && i <= imax && jmin <= j && j <= jmax)
+		{
+			if (gi) *gi = i;
+			if (gj) *gj = j;
+			return true;
+		}
+		return false;
+	}
+	case CIRCLE:
+	{
+		// Loop over all navcells in the given range (starting at (i0,j0) since
+		// this function is meant to find the goal navcell nearest to there
+		// assuming jmin==jmax || imin==imax),
+		// and check whether any point in each navcell is within the goal circle.
+		// (TODO: this is pretty inefficient.)
+		for (int j = j0; jmin <= j && j <= jmax; j += dj)
+		{
+			for (int i = i0; imin <= i && i <= imax; i += di)
+			{
+				entity_pos_t x0 = entity_pos_t::FromInt(i).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+				entity_pos_t z0 = entity_pos_t::FromInt(j).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+				entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE;
+				entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE;
+				entity_pos_t nx = Clamp(x, x0, x1);
+				entity_pos_t nz = Clamp(z, z0, z1);
+				if ((CFixedVector2D(nx, nz) - CFixedVector2D(x, z)).CompareLength(hw) <= 0)
+				{
+					if (gi) *gi = i;
+					if (gj) *gj = j;
+					return true;
+				}
+			}
+		}
+		return false;
+	}
+	case SQUARE:
+	{
+		// Loop over all navcells in the given range (starting at (i0,j0) since
+		// this function is meant to find the goal navcell nearest to there
+		// assuming jmin==jmax || imin==imax),
+		// and check whether any point in each navcell is within the goal square.
+		// (TODO: this is pretty inefficient.)
+		for (int j = j0; jmin <= j && j <= jmax; j += dj)
+		{
+			for (int i = i0; imin <= i && i <= imax; i += di)
+			{
+				entity_pos_t x0 = entity_pos_t::FromInt(i).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+				entity_pos_t z0 = entity_pos_t::FromInt(j).Multiply(ICmpObstructionManager::NAVCELL_SIZE);
+				entity_pos_t x1 = x0 + ICmpObstructionManager::NAVCELL_SIZE;
+				entity_pos_t z1 = z0 + ICmpObstructionManager::NAVCELL_SIZE;
+				entity_pos_t nx = Clamp(x, x0, x1);
+				entity_pos_t nz = Clamp(z, z0, z1);
+				if (Geometry::PointIsInSquare(CFixedVector2D(nx - x, nz - z), u, v, CFixedVector2D(hw, hh)))
+				{
+					if (gi) *gi = i;
+					if (gj) *gj = j;
+					return true;
+				}
+			}
+		}
+		return false;
+	}
+	case INVERTED_CIRCLE:
+	case INVERTED_SQUARE:
+		{
+			// Haven't bothered implementing these, since they're not needed by the
+			// current pathfinder design
+			debug_warn(L"PathGoal::NavcellRectContainsGoal doesn't support inverted shapes");
+			return false;
+		}
+	default:
+	{
+		debug_warn(L"invalid type");
+		return false;
+	}
+	}
+}
+
+bool PathGoal::RectContainsGoal(entity_pos_t x0, entity_pos_t z0, entity_pos_t x1, entity_pos_t z1) const
+{
+	switch (type)
+	{
+	case POINT:
+	{
+		return x0 <= x && x <= x1 && z0 <= z && z <= z1;
+	}
+	case CIRCLE:
+	{
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		return (CFixedVector2D(nx, nz) - CFixedVector2D(x, z)).CompareLength(hw) <= 0;
+	}
+	case SQUARE:
+	{
+		entity_pos_t nx = Clamp(x, x0, x1);
+		entity_pos_t nz = Clamp(z, z0, z1);
+		return Geometry::PointIsInSquare(CFixedVector2D(nx - x, nz - z), u, v, CFixedVector2D(hw, hh));
+	}
+	case INVERTED_CIRCLE:
+	case INVERTED_SQUARE:
+	{
+		// Haven't bothered implementing these, since they're not needed by the
+		// current pathfinder design
+		debug_warn(L"PathGoal::RectContainsGoal doesn't support inverted shapes");
+		return false;
+	}
+	default:
+	{
+		debug_warn(L"invalid type");
+		return false;
+	}
+	}
+}
+
+fixed PathGoal::DistanceToPoint(CFixedVector2D pos) const
+{
+	switch (type)
+	{
+	case PathGoal::POINT:
+		return (pos - CFixedVector2D(x, z)).Length();
+
+	case PathGoal::CIRCLE:
+	case PathGoal::INVERTED_CIRCLE:
+		return ((pos - CFixedVector2D(x, z)).Length() - hw).Absolute();
+
+	case PathGoal::SQUARE:
+	case PathGoal::INVERTED_SQUARE:
+	{
+		CFixedVector2D halfSize(hw, hh);
+		CFixedVector2D d(pos.X - x, pos.Y - z);
+		return Geometry::DistanceToSquare(d, u, v, halfSize);
+	}
+
+	default:
+		debug_warn(L"invalid type");
+		return fixed::Zero();
+	}
+}
Index: source/simulation2/helpers/Grid.h
===================================================================
--- source/simulation2/helpers/Grid.h	(revision 13108)
+++ source/simulation2/helpers/Grid.h	(working copy)
@@ -48,6 +48,7 @@
 
 	Grid(const Grid& g)
 	{
+		m_Data = NULL;
 		*this = g;
 	}
 
@@ -58,6 +59,7 @@
 			m_W = g.m_W;
 			m_H = g.m_H;
 			m_DirtyID = g.m_DirtyID;
+			delete[] m_Data;
 			if (g.m_Data)
 			{
 				m_Data = new T[m_W * m_H];
